Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkXRenderWindowTclInteractor Class Reference

`#include <vtkXRenderWindowTclInteractor.h>`

Inheritance diagram for vtkXRenderWindowTclInteractor:

[legend]
Collaboration diagram for vtkXRenderWindowTclInteractor:

[legend]
List of all members.

## Detailed Description

a TCL event driven interface for a RenderWindow

Date:
  2002/08/22 19:37:49

Revision:
  1.22

vtkXRenderWindowTclInteractor is a convenience object that provides event bindings to common graphics functions. For example, camera and actor functions such as zoom-in/zoom-out, azimuth, roll, and pan. IT is one of the window system specific subclasses of vtkRenderWindowInteractor. Please see vtkRenderWindowInteractor documentation for event bindings.

See also:
  vtkRenderWindowInteractor vtkXRenderWindow

Events:
  vtkCommand::LeftButtonReleaseEvent vtkCommand::RightButtonPressEvent vtkCommand::MouseMoveEvent vtkCommand::MiddleButtonReleaseEvent vtkCommand::ExposeEvent vtkCommand::EnterEvent vtkCommand::TimerEvent vtkCommand::StartEvent vtkCommand::KeyPressEvent vtkCommand::RightButtonReleaseEvent vtkCommand::ConfigureEvent vtkCommand::MiddleButtonPressEvent vtkCommand::CharEvent vtkCommand::LeaveEvent vtkCommand::LeftButtonPressEvent

Created by:
  - Miller, Jim

CVS contributions (if > 5%):
  - Miller, Jim (51%)
  - Martin, Ken (23%)
  - Barre, Sebastien (8%)

CVS logs (CVSweb):
  - .`h` (`/Rendering/vtkXRenderWindowTclInteractor.h)`
  - .`cxx` (`/Rendering/vtkXRenderWindowTclInteractor.cxx)`

Definition at line 57 of file vtkXRenderWindowTclInteractor.h.

## Public Types
typedef vtkRenderWindowInteractor | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | Initialize ()
void | TerminateApp (void)
virtual void | Initialize (XtAppContext app)
virtual XtAppContext | GetApp ()
virtual void | Enable ()
virtual void | Disable ()
virtual void | Start ()
virtual void | UpdateSize (int, int)
virtual void | SetWidget (Widget)
Widget | GetWidget ()
virtual void | SetTopLevelShell (Widget)
Widget | GetTopLevelShell ()
int | CreateTimer (int timertype)
int | DestroyTimer (void)
virtual int | GetBreakLoopFlag ()
virtual void | SetBreakLoopFlag (int)
## Static Public Methods
vtkXRenderWindowTclInteractor * | New ()
int | IsTypeOf (const char *type)
vtkXRenderWindowTclInteractor * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkXRenderWindowTclInteractor ()
| ~vtkXRenderWindowTclInteractor ()
## Protected Attributes
Widget | TopLevelShell
Display * | DisplayId
Window | WindowId
Widget | top
Widget | oldTop
XtAppContext | App
int | PositionBeforeStereo [2]
int | BreakLoopFlag
## Friends
void | vtkXRenderWindowTclInteractorCallback (Widget, XtPointer, XEvent *, Boolean *)
void | vtkXRenderWindowTclInteractorTimer (XtPointer, XtIntervalId *)

## Member Typedef Documentation

typedef vtkRenderWindowInteractor vtkXRenderWindowTclInteractor::Superclass

| Reimplemented from vtkRenderWindowInteractor. Definition at line 61 of file vtkXRenderWindowTclInteractor.h.

## Constructor & Destructor Documentation

vtkXRenderWindowTclInteractor::vtkXRenderWindowTclInteractor | ( |  | ) | `[protected]`

vtkXRenderWindowTclInteractor::~vtkXRenderWindowTclInteractor | ( |  | ) | `[protected]`

## Member Function Documentation

vtkXRenderWindowTclInteractor* vtkXRenderWindowTclInteractor::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkRenderWindowInteractor.

virtual const char* vtkXRenderWindowTclInteractor::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkRenderWindowInteractor.

int vtkXRenderWindowTclInteractor::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkRenderWindowInteractor.

virtual int vtkXRenderWindowTclInteractor::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkRenderWindowInteractor.

vtkXRenderWindowTclInteractor* vtkXRenderWindowTclInteractor::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkRenderWindowInteractor.

void vtkXRenderWindowTclInteractor::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowTclInteractor::Initialize | ( |  | ) | `[virtual]`

| Initializes the event handlers without an XtAppContext. This is good for when you don't have a user interface, but you still want to have mouse interaction. Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowTclInteractor::Initialize | ( | XtAppContext | app | ) | `[virtual]`

| Initializes the event handlers using an XtAppContext that you have provided. This assumes that you want to own the event loop.

virtual XtAppContext vtkXRenderWindowTclInteractor::GetApp | ( |  | ) | `[virtual]`

| Initializes the event handlers using an XtAppContext that you have provided. This assumes that you want to own the event loop.

virtual void vtkXRenderWindowTclInteractor::Enable | ( |  | ) | `[virtual]`

| Enable/Disable interactions. By default interactors are enabled when initialized. Initialize() must be called prior to enabling/disabling interaction. These methods are used when a window/widget is being shared by multiple renderers and interactors. This allows a "modal" display where one interactor is active when its data is to be displayed and all other interactors associated with the widget are disabled when their data is not displayed. Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowTclInteractor::Disable | ( |  | ) | `[virtual]`

| Enable/Disable interactions. By default interactors are enabled when initialized. Initialize() must be called prior to enabling/disabling interaction. These methods are used when a window/widget is being shared by multiple renderers and interactors. This allows a "modal" display where one interactor is active when its data is to be displayed and all other interactors associated with the widget are disabled when their data is not displayed. Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowTclInteractor::Start | ( |  | ) | `[virtual]`

| This will start up the X event loop and never return. If you call this method it will loop processing X events until the application is exited. Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowTclInteractor::UpdateSize | ( | int | ,
|  | int |
| ) | `[virtual]`

| This will start up the X event loop and never return. If you call this method it will loop processing X events until the application is exited. Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowTclInteractor::SetWidget | ( | Widget |  | ) | `[virtual]`

| Specify the Xt widget to use for interaction. This method is one of a couple steps that are required for setting up a vtkRenderWindowInteractor as a widget inside of another user interface. You do not need to use this method if the render window will be a stand-alone window. This is only used when you want the render window to be a subwindow within a larger user interface. In that case, you must tell the render window what X display id to use, and then ask the render window what depth, visual and colormap it wants. Then, you must create an Xt TopLevelShell with those settings. Then you can create the rest of your user interface as a child of the TopLevelShell you created. Eventually, you will create a drawing area or some other widget to serve as the rendering window. You must use the SetWidget method to tell this Interactor about that widget. It's X and it's not terribly easy, but it looks cool.

Widget vtkXRenderWindowTclInteractor::GetWidget | ( |  | ) | `[inline]`

| Specify the Xt widget to use for interaction. This method is one of a couple steps that are required for setting up a vtkRenderWindowInteractor as a widget inside of another user interface. You do not need to use this method if the render window will be a stand-alone window. This is only used when you want the render window to be a subwindow within a larger user interface. In that case, you must tell the render window what X display id to use, and then ask the render window what depth, visual and colormap it wants. Then, you must create an Xt TopLevelShell with those settings. Then you can create the rest of your user interface as a child of the TopLevelShell you created. Eventually, you will create a drawing area or some other widget to serve as the rendering window. You must use the SetWidget method to tell this Interactor about that widget. It's X and it's not terribly easy, but it looks cool. Definition at line 112 of file vtkXRenderWindowTclInteractor.h.

virtual void vtkXRenderWindowTclInteractor::SetTopLevelShell | ( | Widget |  | ) | `[virtual]`

| This method will store the top level shell widget for the interactor. This method and the method invocation sequence applies for: * vtkRenderWindow-Interactor pair in a nested widget hierarchy * multiple vtkRenderWindow-Interactor pairs in the same top level shell It is not needed for: * vtkRenderWindow-Interactor pair as the direct child of a top level shell, * multiple vtkRenderWindow-Interactor pairs, each in its own top level shell. This method, along with EnterNotify event, changes the keyboard focus among the widgets/vtkRenderWindow(s) so the Interactor(s) can receive the proper keyboard events. The following calls need to be made: * vtkRenderWindow's display ID need to be set to the top level shell's display ID. * vtkXRenderWindowInteractor's Widget has to be set to the vtkRenderWindow's container widget. * vtkXRenderWindowInteractor's TopLevel has to be set to the top level shell widget. Note that the procedure for setting up render window in a widget needs to be followed. See vtkRenderWindowInteractor's SetWidget() method. If multiple vtkRenderWindow-Interactor pairs in SEPARATE windows are desired, do not set the display ID (Interactor will create them as needed. Alternatively, create and set distinct DisplayID for each vtkRenderWindow. Using the same display ID without setting the parent widgets will cause the display to be reinitialized every time an interactor is initialized), do not set the widgets (so the render windows would be in their own windows), and do not set TopLevelShell (each has its own top level shell already)

Widget vtkXRenderWindowTclInteractor::GetTopLevelShell | ( |  | ) | `[inline]`

| This method will store the top level shell widget for the interactor. This method and the method invocation sequence applies for: * vtkRenderWindow-Interactor pair in a nested widget hierarchy * multiple vtkRenderWindow-Interactor pairs in the same top level shell It is not needed for: * vtkRenderWindow-Interactor pair as the direct child of a top level shell, * multiple vtkRenderWindow-Interactor pairs, each in its own top level shell. This method, along with EnterNotify event, changes the keyboard focus among the widgets/vtkRenderWindow(s) so the Interactor(s) can receive the proper keyboard events. The following calls need to be made: * vtkRenderWindow's display ID need to be set to the top level shell's display ID. * vtkXRenderWindowInteractor's Widget has to be set to the vtkRenderWindow's container widget. * vtkXRenderWindowInteractor's TopLevel has to be set to the top level shell widget. Note that the procedure for setting up render window in a widget needs to be followed. See vtkRenderWindowInteractor's SetWidget() method. If multiple vtkRenderWindow-Interactor pairs in SEPARATE windows are desired, do not set the display ID (Interactor will create them as needed. Alternatively, create and set distinct DisplayID for each vtkRenderWindow. Using the same display ID without setting the parent widgets will cause the display to be reinitialized every time an interactor is initialized), do not set the widgets (so the render windows would be in their own windows), and do not set TopLevelShell (each has its own top level shell already) Definition at line 142 of file vtkXRenderWindowTclInteractor.h.

int vtkXRenderWindowTclInteractor::CreateTimer | ( | int | timertype | ) | `[virtual]`

| X timer methods. Reimplemented from vtkRenderWindowInteractor.

int vtkXRenderWindowTclInteractor::DestroyTimer | ( | void |  | ) | `[virtual]`

| X timer methods. Reimplemented from vtkRenderWindowInteractor.

void vtkXRenderWindowTclInteractor::TerminateApp | ( | void |  | ) | `[virtual]`

| X Tcl specific application terminate. Reimplemented from vtkRenderWindowInteractor.

virtual int vtkXRenderWindowTclInteractor::GetBreakLoopFlag | ( |  | ) | `[virtual]`

| Set this flag to break the event loop.

virtual void vtkXRenderWindowTclInteractor::SetBreakLoopFlag | ( | int |  | ) | `[virtual]`

| Set this flag to break the event loop.

## Friends And Related Function Documentation

void vtkXRenderWindowTclInteractorCallback | ( | Widget | ,
|  | XtPointer | ,
|  | XEvent * | ,
|  | Boolean * |
| ) | `[friend]`

| Functions that are used internally.

void vtkXRenderWindowTclInteractorTimer | ( | XtPointer | ,
|  | XtIntervalId * |
| ) | `[friend]`

| Functions that are used internally.

## Member Data Documentation

Widget vtkXRenderWindowTclInteractor::TopLevelShell`[protected]`

| Definition at line 172 of file vtkXRenderWindowTclInteractor.h.

Display* vtkXRenderWindowTclInteractor::DisplayId`[protected]`

| Definition at line 174 of file vtkXRenderWindowTclInteractor.h.

Window vtkXRenderWindowTclInteractor::WindowId`[protected]`

| Definition at line 175 of file vtkXRenderWindowTclInteractor.h.

Widget vtkXRenderWindowTclInteractor::top`[protected]`

| Definition at line 176 of file vtkXRenderWindowTclInteractor.h.

Widget vtkXRenderWindowTclInteractor::oldTop`[protected]`

| Definition at line 177 of file vtkXRenderWindowTclInteractor.h.

XtAppContext vtkXRenderWindowTclInteractor::App`[protected]`

| Definition at line 178 of file vtkXRenderWindowTclInteractor.h.

int vtkXRenderWindowTclInteractor::PositionBeforeStereo[2]`[protected]`

| Definition at line 179 of file vtkXRenderWindowTclInteractor.h.

int vtkXRenderWindowTclInteractor::BreakLoopFlag`[protected]`

| Definition at line 181 of file vtkXRenderWindowTclInteractor.h.

The documentation for this class was generated from the following file:

- Rendering/vtkXRenderWindowTclInteractor.h